<?php

/*
 * a set of functions designed to work with tags
 */
function webmail_plus_add_tag($folder, $message_uid, $tag) {
  global $user;

  $folder = trim($folder);
  $message_uid = trim($message_uid);
  $tag = strtolower(trim($tag));

  if($folder=="" || $message_uid=="" || $tag=="") return FALSE;

  // if the tag is already assigned return true
  if(webmail_plus_check_tag($folder, $message_uid, $tag)) return TRUE;

  db_query("INSERT INTO {webmail_plus_user_tags} (uid,folder,message_uid,tag) VALUES(%d, '%s', %d, '%s')", $user->uid, $folder, $message_uid, $tag);


  return TRUE;
}

/*
 * returns TRUE if this tag is already assigned to the message
 */
function webmail_plus_check_tag($folder, $message_uid, $tag) {
  global $user;

  $folder = trim($folder);
  $message_uid = trim($message_uid);
  $tag = strtolower(trim($tag));

  if($folder=="" || $message_uid=="" || $tag=="") return FALSE;

  $count = db_result(db_query("SELECT COUNT(*) FROM {webmail_plus_user_tags} WHERE uid=%d AND message_uid=%d AND tag='%s'", $user->uid, $message_uid, $tag));

  if($count>0) {
    return TRUE;
  } else {
    return FALSE;
  }

}

/**
 * removes a particular tag from the message
 *
 * @param unknown_type $folder
 * @param unknown_type $message_uid
 * @param unknown_type $tag
 * @return unknown
 */
function webmail_plus_remote_tag($folder, $message_uid, $tag) {
  global $user;

  $folder = trim($folder);
  $message_uid = trim($message_uid);
  $tag = strtolower(trim($tag));

  if($folder=="" || $message_uid=="" || $tag=="") return FALSE;

  db_query("DELETE FROM {webmail_plus_user_tags} WHERE uid=%d AND folder='%s', message_uid=%d AND tag='%s'", $user->uid, $folder, $message_uid, $tag);

  return TRUE;
}


/**
 * removes all tags associated with the message
 *
 * @param unknown_type $folder
 * @param unknown_type $message_uid
 * @param unknown_type $folder
 * @param unknown_type $message_uid
 * @return unknown
 */
function webmail_plus_flush_tags($folder, $message_uid) {
  global $user;


  $folder = trim($folder);
  $message_uid = trim($message_uid);

  if($folder=="" || $message_uid=="") return FALSE;

  db_query("DELETE FROM {webmail_plus_user_tags} WHERE uid=%d AND folder='%s' AND message_uid=%d", $user->uid, $folder, $message_uid);

  return TRUE;

}

/**
 * returns all tags associated with a message
 */
function webmail_plus_get_message_tags($folder, $message_uid) {
  global $user;

  $folder = trim($folder);
  $message_uid = trim($message_uid);

  if($folder=="" || $message_uid=="") return FALSE;


  $result = db_query("SELECT CONCAT(uid,'-',folder,'-',message_uid), tag FROM {webmail_plus_user_tags} WHERE uid=%d AND folder='%s' AND message_uid=%d", $user->uid, $folder, $message_uid);

  while($record = db_fetch_object($result)) {
    $tag = $record->tag;
    $tag = trim($tag);
    if($tag=="") continue;
    $tags[]=$record->tag;
  }



  return $tags;

}

/**
 * returns all tags created by the user
 * takes UID as input
 * if UID is blank, uses current uid
 *
 * @param unknown_type $uid
 */
function webmail_plus_get_user_tags($uid="", $max=NULL) {
  global $user;

  if($uid=="") $uid = $user->uid;
  if(!$max) {
    $result = db_query("SELECT tag, count( * ) AS popularity FROM {webmail_plus_user_tags} WHERE uid=%d GROUP BY tag ORDER BY popularity DESC", $uid);
  }
  else {
    $result = db_query("SELECT tag, count( * ) AS popularity FROM {webmail_plus_user_tags} WHERE uid=%d GROUP BY tag ORDER BY popularity DESC LIMIT %d", $uid, $max);  	
  }
  
  while($record = db_fetch_object($result)) {
    $this_tag = trim($record->tag);
    if($this_tag=='') continue;
    $tags[]=$this_tag;
  }

  return $tags;

}


?>